function [znum1,znum2,zden1,zden2,ActualSamplingRatio1,ActualSamplingRatio2,timer1,timer2] = core_inner(y,ymean,x,xmean,xmeansort,h,win,d,m,n,xhist_idx_randperm,xhist_count,xhist_boundary,iset,SamplingRatio_list,SamplingRatio_length)

timer1 = zeros(SamplingRatio_length,1);
timer2 = zeros(SamplingRatio_length,1);

ActualSamplingRatio1 = zeros(SamplingRatio_length,1);
ActualSamplingRatio2 = zeros(SamplingRatio_length,1);

znum1 = zeros(m,SamplingRatio_length);
znum2 = zeros(m,SamplingRatio_length);
zden1 = zeros(m,SamplingRatio_length);
zden2 = zeros(m,SamplingRatio_length);

for sid=1:SamplingRatio_length
    SamplingRatio = SamplingRatio_list(sid);
    
    timer0 = tic;
    tau = compute_tau(ymean, xmeansort, SamplingRatio, h, m, n);
    [znumtmp1,zdentmp1,ActualNumSample1] = mcnlm_external_intensity(y,ymean,x,xmean,h,win,tau,xhist_idx_randperm,xhist_count,xhist_boundary,iset,SamplingRatio);
    timer1(sid) = toc(timer0);
    
    timer0 = tic;
    [znumtmp2,zdentmp2,ActualNumSample2] = mcnlm_external_uniform(y,x,h,win,SamplingRatio,iset);
    timer2(sid) = toc(timer0);
    
    ActualSamplingRatio1(sid) = mean(ActualNumSample1/n);
    ActualSamplingRatio2(sid) = mean(ActualNumSample2/n);
    
    znum1(:,sid) = znumtmp1;
    zden1(:,sid) = zdentmp1;
    znum2(:,sid) = znumtmp2;
    zden2(:,sid) = zdentmp2;
end