clear all
close all
clc

% This routine displays the values of Tables I
%
% Stanley Chan @ Harvard
% May 23, 2013
% Apr 11, 2014

sigma_set = 10:10:50;
fprintf('sigma \t\t 0.05 \t\t\t 0.1 \t\t\t 0.2 \t\t\t 0.5 \t\t\t 1 \t\t\t\t GKD \t\t\t AM \t\t\t BM3D \n');
fprintf('-------------------------------------------------------------------------------------------------------------------------------------\n');
for j=1:10
    
    if mod(j,2)==1
        str1 = ' \t & \t %3.2f ';
        str2 = ['%3g ', str1, str1, str1, str1, str1, str1, str1, str1, '\n'];
        for i=1:5
            sigma = sigma_set(i);
            fname = sprintf('../data/Table1_data/change_both_win%02d_sigma%02d.mat',10,sigma);
            load(fname);
            fprintf(str2, ...
                sigma,...
                sum(sum(psnr_mcnlm(:,:,1,i,j)))/(size(psnr_mcnlm,1)*size(psnr_mcnlm,2)),...
                sum(sum(psnr_mcnlm(:,:,2,i,j)))/(size(psnr_mcnlm,1)*size(psnr_mcnlm,2)),...
                sum(sum(psnr_mcnlm(:,:,3,i,j)))/(size(psnr_mcnlm,1)*size(psnr_mcnlm,2)),...
                sum(sum(psnr_mcnlm(:,:,4,i,j)))/(size(psnr_mcnlm,1)*size(psnr_mcnlm,2)),...
                mean(psnr_full(:,i,j)),...
                mean(psnr_kd(:,i,j)),...
                mean(psnr_am(:,i,j)),...
                mean(psnr_bm3d(:,i,j)));
        end
        fprintf('-------------------------------------------------------------------------------------------------------------------------------------\n');
    else
        str1 = ' \t & \t %3.2f ';
        str2 = ['\t', str1, str1, str1, str1, str1, str1, str1, str1, '\n'];
        for i=1:5
            sigma = sigma_set(i);
            fname = sprintf('../data/Table1_data/change_both_win%02d_sigma%02d.mat',10,sigma);
            load(fname);
            fprintf(str2, ...
                sum(sum(psnr_mcnlm(:,:,1,i,j)))/(size(psnr_mcnlm,1)*size(psnr_mcnlm,2)),...
                sum(sum(psnr_mcnlm(:,:,2,i,j)))/(size(psnr_mcnlm,1)*size(psnr_mcnlm,2)),...
                sum(sum(psnr_mcnlm(:,:,3,i,j)))/(size(psnr_mcnlm,1)*size(psnr_mcnlm,2)),...
                sum(sum(psnr_mcnlm(:,:,4,i,j)))/(size(psnr_mcnlm,1)*size(psnr_mcnlm,2)),...
                mean(psnr_full(:,i,j)),...
                mean(psnr_kd(:,i,j)),...
                mean(psnr_am(:,i,j)),...
                mean(psnr_bm3d(:,i,j)));
        end        
        fprintf('-------------------------------------------------------------------------------------------------------------------------------------\n');
    end
end