function g = my_compute_non_local_means_basis(f, win)
[M,N,K] = size(f);
fpad = padarray(f,[win,win],'symmetric');
g = zeros(M,N,K*(2*win+1)^2);
for i=win+1:M+win
    for j=win+1:N+win
        block = fpad(i+[-win:win], j+[-win:win], :);
        g(i-win,j-win,:) = block(:);
    end
end